public class Polynom implements Funktion {

    private double[] koeff; // Koeffizienten a_0, ... , a_n
                            // koeff[i] entspricht a[i]

    public Polynom(double[] koeffizienten) {
        this.koeff = koeffizienten;
    }

    public double eval(double x) {
        double val = 0.0;

	// Auswertung nach Horner-Schema
	// f(x) = (...((a_n x + a_{n-1})x + a_{n-2}) + .... ) + a_0
	//      = a_n x^n + a_{n-1} x^{n-1} + ... + a_1 x + a_0
        for (int i=koeff.length-1 ; i>=0 ; i--) {
	   val = val*x + koeff[i];
	}

	return val;
    }

    public Funktion differenziere() {
        double dkoeff[];

	if (this.koeff.length <= 1) {
	    dkoeff = new double[1];
	}
	else {
	    dkoeff = new double[this.koeff.length-1];

	    for (int i=1 ; i<this.koeff.length ; i++) {
	        dkoeff[i-1] = i*koeff[i];
	    }
	}

	return new Polynom(dkoeff);
    }
}
